#include <stdlib.h>
#include <stdio.h>
#include	<dir.h>
#include	<process.h>

#define		FALSE			0
#define		TRUE			1
#define		CR				0xd
#define		LF				0xa

FILE		*incos_file, *out_file;
char		buff[80];
char		int_per_row[12][12];

union 		val {
		char		l_char[18];
		unsigned short	l_value[9];
}val;

void	swap_it(void);

main(argc,argv)
int		argc;
char	*argv[];
{
	char	szLogName[80];
	char	szIncosName[80];
	int		n, m, m_back, x, flag;
	printf("\n\n         Copyright (C) 1995 MasCom GmbH Bremen\n\n\
	Converts INCOS LOG files into binary files.\n\n\
	Input: LOGCONV LogFileName IncosFileName\n\
	p.e.   LOGCONV QDEMOX.LOG QDEMO.MX\n\n");
	if(argc < 3)
	{
		printf("\nWrong input!");
		return TRUE;
    }
	strcpy(szLogName, *++argv);
	strcpy(szIncosName, *++argv);
	if((incos_file = fopen(szLogName, "r")) == NULL)
	{
		printf("\nNo such file %s", szLogName);
		return TRUE;
	}
	if((out_file = fopen(szIncosName, "wb")) == NULL)
	{
		printf("\nCan not create %s file", szIncosName);
		return TRUE;
	}
	n = 0;
	do
	{
		fread(&buff[n], 1, 1, incos_file);
	}while(buff[n++] != LF);
	while(TRUE)
	{
		n = 0;
		fread(&buff[n++], 1, 1, incos_file);
		if(buff[0] == '+')
			break;
		do
		{
			fread(&buff[n], 1, 1, incos_file);
		}while(buff[n++] != LF);
		flag = TRUE;
		for(n=0, m=0, x=0; n<=80; n++)
		{
			if(buff[n] == ' ' && !flag)
			{
				m++;
				x = 0;
				flag = TRUE;
			}
			int_per_row[m][x] = buff[n];
			x++;	
			if(buff[n] == LF)
				break;
			if(flag && buff[n] != ' ')
			{
				flag = FALSE;
			}
		}
		m_back = m;
		do
		{
			val.l_value[m] = atoi(&int_per_row[m][0]);
		} while(m--);
		swap_it();
		fwrite(&val.l_value[1], 2, m_back , out_file);
	}
	fclose(incos_file);
	fclose(out_file);
	return(0);
}

void	swap_it(void)
{
	char	back_up;
	int		n=0;
	while(n <= 9)
	{
		back_up = val.l_char[2*n];
		val.l_char[2*n]=val.l_char[2*n+1];
		val.l_char[2*n+1]=back_up;
		n++;
	}
}
